# """
# /***************************************************************************
# Name                 : shptoobs
# Description          : Creates a RayMan input file from shp. 
# Date                 : 11/Bec/13 
# copyright            : (C) 2017 by Tamas Gal, Dominik Froehlich
# email                : dominik.froehlich@mailbox.org 
#  ***************************************************************************/
# """

# import os # not needed any more?
from sys import exit
# Import the PyQt and QGIS libraries
from PyQt4.QtCore import * 
from PyQt4.QtGui import *
from qgis.utils import showPluginHelp
from PyQt4 import QtCore, QtGui
from qgis.core import *
from math import *
import os
import csv
import random
# Initialize Qt resources from file resources.py
import resources
# Import the code for the dialog
from shpobs_Step1 import Ui_shpobsStep1 as Dlg1
from shpobs_Step2 import Ui_shpobsStep2 as Dlg2

class ShowDialog1(QtGui.QDialog, Dlg1): 
    def __init__(self): 
        QtGui.QDialog.__init__(self)
        self.setupUi(self) 

class ShowDialog2(QtGui.QDialog, Dlg2): 
    def __init__(self): 
        QtGui.QDialog.__init__(self)
        self.setupUi(self) 

class shp_to_obs: 
  
  def __init__(self, iface):
    # Save reference to the QGIS interface
    self.iface = iface

  def initGui(self):  
    # Create action that will start plugin configuration
    self.action = QAction(QIcon(":/plugins/shp_to_obs/icon.png"), \
        "shp_to_obs", self.iface.mainWindow())
    # connect the action to the run method
    # QObject.connect(self.action, SIGNAL("activated()"), self.run) # depr!
    self.action.activated.connect(self.run)
    
    # check if Vector menu available (Version 1.9 or higher)
    if hasattr(self.iface, "addPluginToVectorMenu"):
      # Vector menu and toolbar available
      self.iface.addVectorToolBarIcon(self.action)
      self.iface.addPluginToVectorMenu("&shp_to_obs", self.action)
    else:
      # there is no Vector menu, place plugin under Plugins menu as usual
      self.iface.addToolBarIcon(self.action)
      self.iface.addPluginToMenu("&shp_to_obs", self.action)

  def unload(self):  
    # check if Vector menu available and remove our buttons from appropriate
    # menu and toolbare
    if hasattr(self.iface, "addPluginToRasterMenu"):
      self.iface.removePluginVectorMenu("&shp_to_obs",self.action)
      self.iface.removeVectorToolBarIcon(self.action)
    else:
      self.iface.removePluginMenu("&shp_to_obs",self.action)
      self.iface.removeToolBarIcon(self.action)
  
  def getFields(self, lyr):
    # returns fields for layer
    dp = lyr.dataProvider()
    fnm = dp.fieldNameMap()
    lst = []
    for key in fnm:
      lst.append(key)
    lst.sort() # .reverse()
    return lst
  
  def extract_attribute(self, layer, field_index): 
     if (layer.isValid() and field_index >= 0):
        features = layer.getFeatures()
        attr_list = []
        # calculate field index
        field_list = self.getFields(layer)
        field_name = str(field_list[field_index])
        for feature in features:
          # attr = str(feature[field_index]).lower()
          try:
            attr_list.append(float(feature[field_name])) 
          except:
            attr_list.append(str(feature[field_name]).lower())
          # if (attr == "l") or (attr == "n"):
          #   attr_list.append(attr)
          # else:
          #   attr_list.append(float(attr))
        return attr_list
     else:
        QMessageBox.critical(None, "Attribute extraction faild", str("Invalid layer or field index: Layer = " + str(layer.name()) + " Field Nr. = " + str(field_index)))
  
  def extract_point_coord(self, layer): # delivers less geometries, than actualy present. Why?
     # function to extract point coordinates from a layer
     if layer.isValid():
        features = layer.getFeatures()
        xy_list = []
        invalid = 0
        abort = False
        for feature in features:
          if feature.isValid():
            geom = feature.geometry()
            x = float(geom.asPoint().x())
            y = float(geom.asPoint().y())
            xy = []
            xy.append(x)
            xy.append(y)
            xy_list.append(xy)
          else:
            invalid = invalid + 1
            continue
        if (invalid > 0):
          QMessageBox.critical(None, "Reading point geometry faild!", str("Reading out point geometry faild due to " + str(invalid) + " invalid features!"))
          abort = True
        return(xy_list, abort)
  
  def extract_poly_geometry(self, layer): 
     if layer.isValid():
       features = layer.getFeatures()
       geom_list = []
       invalid = 0
       for feature in features:
         if feature.isValid():
           geom_list.append( QgsGeometry( feature.geometry() ) )
         else:
           invalid = invalid + 1
       if (invalid > 0):
         QMessageBox.critical(None, "Check selected layer!", str("Your buildings layer contains " + str(invalid) + "invalid features!"))
       return geom_list
     else:
       QMessageBox.critical(None, "Check selected layer!", ":-/ Faild to load buildings layer! (Extract polygon geometry routine):-/" )

  
  def projectfilepathname(self): 
        # function to extract the file path and name of the current project file
        # self.mainWindow().statusBar().showMessage("Getting project name and path")
        prjfi = QFileInfo(QgsProject.instance().fileName())
        path_name = []
        if prjfi:
            path_name.append(str(prjfi.absolutePath()))
            filename = str(prjfi.fileName())
            if filename.count(".") > 0:
               path_name.append(filename.split(".")[0])
            else:
               path_name.append(filename)
            path_name.append(prjfi.fileName())
        else:
            path_name.append(r'C:\Users')
            path_name.append(r'test')
        return path_name

  def build_Layer_Index_Changed(self, index):
        if index >= 0:
            build = canvas.layer(index)
            build_fields = []  # to avoid to adress build_fields before assignment if getFields fails
            try:
              build_fields = self.getFields(build)
            except:
              QMessageBox.critical(None, "Check selected layer!", ":-/ Faild to load buildings layer! (build_Layer_Index_Changed) :-/" )
            dlg2.Sel_buildhight_field.clear()
            # build_fields.reverse()
            dlg2.Sel_buildhight_field.addItems(build_fields)
        
  def tree_Layer_Index_Changed(self, index):
          if index == 0:
            dlg2.treesconf.setEnabled(False)
          else:
            if index >= 0:
              trees = canvas.layer(index - 1)
              try:
                trees_fields = self.getFields(trees)
                # trees_fields.reverse()
              except:
                QMessageBox.critical(None, "Check selected layer!", ":-/ Faild to load tree layer! (tree_Layer_Index_Changed) :-/" )
              dlg2.treesconf.setEnabled(True)
              dlg2.Sel_treehight_field.clear()
              dlg2.Sel_treehight_field.addItems(trees_fields) 
              dlg2.Sel_crownexp_field.clear()
              dlg2.Sel_crownexp_field.addItems(trees_fields)
              dlg2.Sel_treetype_field.clear()
              dlg2.Sel_treetype_field.addItems(trees_fields) 
              dlg2.Sel_trunchight_field.clear()
              dlg2.Sel_trunchight_field.addItems(trees_fields)
              dlg2.Sel_truncrad_field.clear()
              dlg2.Sel_truncrad_field.addItems(trees_fields)
        
  def centerpoints_Layer_Index_Changed(self, index):
          if index > 0:
            center_points = canvas.layer(index - 1)
            try:
              center_points_fields = self.getFields(center_points)
            except:
              QMessageBox.critical(None, "Check selected layer!", ":-/ Faild to load center point(s) layer! :-/" )
            dlg2.Sel_centerpoints_field.clear()
            # center_points_fields.reverse()
            dlg2.Sel_centerpoints_field.addItems(center_points_fields)

  def deleteDoubleVertices(self, thepoints):
    validPoints = []
    validPoints.append(thepoints[0])  # first point is always valid!
    for i in range(len(thepoints) - 1):
      p1 = thepoints[i + 1]
      p2 = thepoints[i]
      if (not ((p1.x() == p2.x()) and (p1.y() == p2.y()))):
        validPoints.append(p1)  # only copy next point if not the same as before
    return validPoints

  def find_closestVertices(self, set1, set2):
    p1 = set1[0]
    p2 = set2[0]
    vertnums = []
    vertnums.append(0)  # vertNum1
    vertnums.append(0)  # vertNum2
    pdist = abs(p1.x() - p2.x()) + abs(p1.y() + p2.y())
    for i in range(len(set1)):
      p1 = set1[i]
      for j in range(len(set2)):
        p2 = set2[j]
        temp_pdist = abs(p1.x() - p2.x()) + abs(p1.y() + p2.y())
        if(temp_pdist < pdist):
          vertnums[0] = i
          vertnums[1] = j
          pdist = temp_pdist
    return(vertnums)

  def insert_ring(self, r, insert_at, mainset, ringset):
    ringset = self.deleteDoubleVertices(ringset)  # delete double vertices from inner ring
    p1 = ringset[0]
    p2 = ringset[-1]
    if (((p1.x() == p2.x()) and (p1.y() == p2.y()))):  # make sure the first and last point of the ringet are not the same!
      del ringset[-1]
    # odd = floor(r / 2.0) < (r / 2.0)  # ring has odd number? Then is inner one. Insert reverse!
    newPoints = []
    mainp = len(mainset)  # number of points in main set
    ringp = len(ringset)  # number of points in ring to insert
    for i in range(insert_at[0] + 1):  # copy all points bevore
      newPoints.append(mainset[i])
    for j in range(ringp):
      # target_index = insert_at[0] + 1 + j
      # if(odd):
      #   ring_index = insert_at[1] - j  # rather invert all additionnal rings as this works more likely
      # else:
      ring_index = insert_at[1] + j  # or not invert at all?
      # if(ring_index < 0):
      #   ring_index = ring_index + ringp
      if(ring_index >= ringp):
        ring_index = ring_index - ringp
      newPoints.append(ringset[ring_index])
    newPoints.append(ringset[insert_at[1]])  # repeat first ring point to close ring
    newPoints.append(mainset[insert_at[0]])  # repeat insert point of main set to integrate the ring
    for k in range(mainp - 1 - insert_at[0]):  # copy rest of original set
      # target_index = insert_at[0] + ringp + 3 + k
      source_index = insert_at[0] + 1 + k
      newPoints.append(mainset[source_index])
    # QMessageBox.information(None, "DEBUG", str("mainset(" + str(len(mainset)) + "): " + str(mainset) + '\n' + "newPoints(" + str(len(newPoints)) + "): " + str(newPoints) + '\n' + "ringset(" + str(len(ringset)) + "): " + str(ringset)))
    return(newPoints)
  
  def shwhelp(self):
     showPluginHelp()
        
  def ConvertFunction(self): #, canvas, dlg2):   ################################## Main program start ###########################
    
    # Read layers
    build = canvas.layer(int(dlg2.Sel_Build_Layer.currentIndex()))
    if (dlg2.treesconf.isEnabled()):
       trees = canvas.layer(int(dlg2.Sel_Tree_Layer.currentIndex()) - 1)
    if (dlg2.Sel_centerpoints_field.currentIndex() > 0):
       center_points = canvas.layer(int(dlg2.Sel_centerpoints_layer.currentIndex()) - 1)  # -1 to consider the "- none -" field
    
    
    ####   variable definitions   ###
    if (build.isValid()):
      if (int(dlg2.Sel_buildhight_field.currentIndex()) >= 0):
        # The center point(s) for the obstacle file(s) (point shape, it have to be loaded into the View window)
        if (int(dlg2.Sel_centerpoints_field.currentIndex()) >= 0 and center_points.isValid()):
          PointElevation = int(dlg2.Sel_centerpoints_field.currentIndex()) #Field name of the center point(s) elevation
        else:
          PointElevation = -1
        
        BuildingElevation = int(dlg2.Sel_buildhight_field.currentIndex()) #Field name of the elevation of the top of the buildings in the attribute table
        
        # Vegetation data (point shape, it have to be loaded into the View window)
        VH = dlg2.Sel_treehight_field.currentIndex() #Field name of the height of the three in the attribute table
        VR = dlg2.Sel_crownexp_field.currentIndex() #Field name of the radius of the three crown in the attribute table
        VL = dlg2.Sel_trunchight_field.currentIndex() #Field name of the height of the trunk in the attribute table
        VD = dlg2.Sel_truncrad_field.currentIndex() #Field name of the radius of the trunk in the attribute table
        VT = dlg2.Sel_treetype_field.currentIndex() #Field name of the type of the three in the attribute table
        
        #*Output directory and filename (the script will put a number after the filename if there are more then one center point)*
        OutputDir = str(dlg2.outdir.text())
        OutputName = str(dlg2.outfile.text())
        
        abort = False
        
        MaxIteration = 500
        
        #*** end of variable definitions ***
        
        if (dlg2.treesconf.isEnabled()):                                                             # Trees
          # theFAFtab = theFATheme.GetFTab # attribute table
          # theFAShapeField = theFAFtab.FindField("Shape") # geometry   
          theFAShapeField = self.extract_point_coord(trees)
          if(theFAShapeField[1] == True):
            # exit("Reading tree geometry failed!") # Closes QGIS! Bug?
            abort = True
          theFAShapeField = theFAShapeField[0]
          # select reads data from Povider (Field Index, Extension (spatial), Shape, Intersect test)
          theFAHField = self.extract_attribute(trees, VH)  # variables (see above)
          theFARField = self.extract_attribute(trees, VR)
          theFALField = self.extract_attribute(trees, VL)
          theFADField = self.extract_attribute(trees, VD)
          theFATipeField = self.extract_attribute(trees, VT)
          # QMessageBox.information(None, "DEBUG:", str("theFAHField = " + str(VH) + " theFARField = " + str(VR) + " theFALField = " + str(VL)))
        # Buildings
        theINPolyShapeField = self.extract_poly_geometry(build)
        theINPolyHField = self.extract_attribute(build, BuildingElevation) # and elevation
        # Center points
        if(PointElevation > -1):  # check if center points layer is present
          theOUTHField  = self.extract_attribute(center_points, PointElevation) # relative height of buildings to center point
          theOUTShapeField = self.extract_point_coord(center_points) # geometry (x, y, coordinate)
          if(theOUTShapeField[1] == True):
            abort = True
          theOUTShapeField = theOUTShapeField[0]
        else:  # if no layer present set center of buildings layer as center point
          theOUTHField = []
          theOUTHField.append(0.0)  # use offset of 0m if not set
          theOUTShapeField = []
          theOUTShapeField.append(build.extent().center())  # returns center point, tested on console, works
        
        
        if(abort == False):
          showUnsuppostedGeometryType = True
          for i in range(len(theOUTShapeField)):  
            # QMessageBox.information(None, "DEBUG:", str("Working on center point " + str(i+1) + " of " + str(len(theOUTShapeField))))
            thecentershape = theOUTShapeField[i] # actual center point
            cx = thecentershape[0] # gets x coordinate  
            cy = thecentershape[1] # resp.
            ch = theOUTHField[i] # elevation
            
            NumberedFileName = str(OutputName + str(i) + ".obs")
            name = os.path.join(OutputDir, NumberedFileName) # Creates full name for output file intelligently
            field_delimiter = " "
            # line_terminator = ""
            try:                                     # Try/Except block for file operation
              OutputFile = open(name, 'w')
            except:
              QMessageBox.critical(None, "Error", str("Failure opening " + name))
            writer = csv.writer(OutputFile, delimiter = field_delimiter, quotechar = '#', lineterminator = '\n')
            writer.writerow([str(" RayMan Pro obstacle file ")]) # write header
            
            for a in range(len(theINPolyShapeField)): # going through buildings
              
              # QMessageBox.information(None, "DEBUG:", str("Working on object " + str(a+1) + " of " + str(len(theINPolyShapeField))))
              thepoly = theINPolyShapeField[a] # extract building number a
              polyarea = float(thepoly.area()) # returning area 
              if(round(polyarea, 2) > 0.005): # ignore every polygon of area smaller than 0.005 m^2
                thepoints = []
                # if(len(thepoly.asPolygon()) > 0):
                if((thepoly.wkbType() == 3) or (thepoly.wkbType() == -2147483645)):  # if the geometry is a normal polygon
                  curPol = thepoly.asPolygon()
                  if(len(curPol) > 1):  # if the geometry contains more than one ring
                    for p in range(len(curPol[0])): # iterate over the first ring and copy points to thepoints
                      thepoints.append(curPol[0][p]) # list with point of vertexes. Like [(3.41399e+06,5.3181e+06), (3.41398e+06,5.31808e+06)]
                    for r in range(1, len(curPol)):
                      newring = []  # empty container to store items of the new ring temporarily
                      for p in range(len(curPol[r])): # iterate over the rings and copy point coordinates
                        newring.append(curPol[r][p]) # list with point of vertexes. Like [(3.41399e+06,5.3181e+06), (3.41398e+06,5.31808e+06)]
                      insert_at = self.find_closestVertices(thepoints, newring)
                      thepoints = self.insert_ring(r, insert_at, thepoints, newring)
                  else:
                    for p in range(len(curPol[0])):   # only for 1st geometry of only one present
                      thepoints.append(curPol[0][p]) # list with point of vertexes.
                else:
                  # QMessageBox.critical(None, "DEBUG:", str("length of thepoly not > 0!!! theINPolyShapeField[a] = " + str(theINPolyShapeField[a]) + ", Building no. = " + str(a)))
                  # if(len(thepoly.asMultiPolygon()) > 0):
                  if((thepoly.wkbType() == 6) or (thepoly.wkbType() == -2147483642)):  # if the geometry is a MultiPolygon
                    curPol = thepoly.asMultiPolygon()
                    for pol in range(len(curPol)): # iterate over the polygons of the MultiPolygon
                      for p in range(len(curPol[pol][0])): # iterate over the first ring and copy points to thepoints
                        thepoints.append(curPol[pol][0][p]) # list with point of vertexes. Like [(3.41399e+06,5.3181e+06), (3.41398e+06,5.31808e+06)]
                      for r in range(len(curPol[pol])): # iterate over the rings of the polygon
                        newring = []  # empty container to store items of the new ring temporarily
                        for p in range(1, len(curPol[pol][r])):  # iterate over the points of the ring
                          newring.append(curPol[pol][r][p]) # list with point of vertexes. Like [(3.41399e+06,5.3181e+06), (3.41398e+06,5.31808e+06)]
                        insert_at = self.find_closestVertices(thepoints, newring)
                        thepoints = self.insert_ring(r, insert_at, thepoints, newring)
                  else:  # if nothing works fail with error
                    if(showUnsuppostedGeometryType):
                      QMessageBox.critical(None, "DEBUG:", str("Building no. = " + str(a) + " is of unsupported geometry type" + str(thepoly.wkbType()) + ". Further errors of the same type will not be displayed." ))
                      showUnsuppostedGeometryType = False
                    continue
                
                thepoints = self.deleteDoubleVertices(thepoints)  # delete vertices with same position
                # QMessageBox.information(None, "DEBUG", str("thepoints(" + str(len(thepoints)) + "): " + ("[%f]"%", ".join(map(str,thepoints)))))  # str("%.9f" % thepoints)))
                pnum = len(thepoints)  # number of points
                t1 = pnum / 2.0   # pair test
                t2 = ceil(t1)
                t3 = floor(t1)
                tr1 = 1
                
                if (t2 < t3):  # if residual after deviding by 2
                  pncount = len(thepoints)
                  pn1 = thepoints[pncount-2] # pick some point | remember index is 0 to n-1!!!
                  pn2 = thepoints[pncount-1] # another point (last one)
                  pn3x = pn2.x()+((pn1.x() - pn2.x())/2.0) # create a new vertex between last and one before last point. 
                  pn3y = pn2.y()+((pn1.y() - pn2.y())/2.0)
                  pn3 = QgsPoint(pn3x,pn3y)
                  thepoints.remove(pn2)
                  thepoints.remove(pn1)
                  thepoints.append(pn1) # only for order in file (becomes important later)
                  thepoints.append(pn3)
                  thepoints.append(pn2)       
                f1=0
                f2=0
                
                while (tr1 == 1): #iteration for dividing the buidings
                  num = len(thepoints)
                  tr2 = 1
                  f1 = f1 + 1
                  if (f1 > MaxIteration):
                    break
                  while (tr2 == 1):
                    f2 = f2 + 1
                    if (f2 > MaxIteration):
                      break
                    
                    if (num <= 3):  # num is 0 here. Why?
                      break
                    else:
                      pointnum = random.randint(0, num - 1) # choose random point between first and one before last point
                      point1 = thepoints[pointnum]
                      if (pointnum == 0):
                        point2 = thepoints[num - 1]
                      else:
                        point2 = thepoints[pointnum - 1] # select one neighbouring point, 
                      
                      if (pointnum == (num - 1)):
                        point3 = thepoints[0]
                      else:
                        point3 = thepoints[pointnum + 1]
                      
                      testpolygon = QgsGeometry.fromPolygon( [[ point1, point2, point3, point1 ]] ) # test polygon for making sure triangle is inside buiding
                      #             QgsGeometry.fromPolygon( [ [ QgsPoint(1,1), QgsPoint(2,2), QgsPoint(2,1) ] ] )
                      if (thepoly.contains(testpolygon)): # if polygon contains test line
                        tr2 = 0
                        thepoints.remove(point1) # removes point one from list of all points
                        num = num - 1 # number of all points decreased by one
                        
                        p1x = point1.x() # coordinates of point one
                        p1y = point1.y()
                        p1z = theINPolyHField[a] # z coordinate from polygone
                        p2x = point2.x()
                        p2y = point2.y()
                        p2z = theINPolyHField[a]
                        p3x = point3.x()
                        p3y = point3.y()
                        p3z = theINPolyHField[a]
                        p4x = point3.x() + ((point1.x() - point3.x()) / 2.0) # fourth point between points 1 and three
                        p4y = point3.y() + ((point1.y() - point3.y()) / 2.0)
                        p4z = theINPolyHField[a]
                        
                        np1x = '%.2f' % round(p1x - cx, 2) # calculates coordinates from those of point and center points (x-dir)
                        np1y = '%.2f' % round(p1y - cy, 2) # y dir
                        np1z = '%.2f' % round(p1z - ch, 2) # z dir
                        
                        np2x = '%.2f' % round(p2x - cx, 2) # resp
                        np2y = '%.2f' % round(p2y - cy, 2)
                        np2z = '%.2f' % round(p2z - ch, 2)
                         
                        np3x = '%.2f' % round(p3x - cx, 2)
                        np3y = '%.2f' % round(p3y - cy, 2)
                        np3z = '%.2f' % round(p3z - ch, 2)
                        
                        np4x = '%.2f' % round(p4x - cx, 2)
                        np4y = '%.2f' % round(p4y - cy, 2)
                        np4z = '%.2f' % round(p4z - ch, 2)       
                        
                        np5x = '%.2f' % round(p1x - cx, 2) # lower points
                        np5y = '%.2f' % round(p1y - cy, 2)
                        np5z = '%.2f' % round(0, 2)
                        
                        np6x = '%.2f' % round(p2x - cx, 2)
                        np6y = '%.2f' % round(p2y - cy, 2)
                        np6z = '%.2f' % round(0, 2)
                        
                        np7x = '%.2f' % round(p3x - cx, 2)
                        np7y = '%.2f' % round(p3y - cy, 2)
                        np7z = '%.2f' % round(0, 2)
                        
                        np8x = '%.2f' % round(p4x - cx, 2)
                        np8y = '%.2f' % round(p4y - cy, 2)
                        np8z = '%.2f' % round(0, 2)
                        
                        # theoutline = str("g "+ str(np1x) +" "+ str(np1y) +" "+ str(np1z) +" " + str(np2x) +" "+ str(np2y) +" " + str(np2z)+" "+ str(np3x) + " " + str(np3y) + " " + str(np3z) + " " + str(np4x) + " " + str(np4y) + " " + str(np4z) + " " + str(np5x) + " " + str(np5y) + " " + str(np5z) + " " + str(np6x) + " " + str(np6y) + " " + str(np6z) + " " + str(np7x) + " " + str(np7y) + " " + str(np7z) + " " + str(np8x) + " " + str(np8y) + " " + str(np8z) + " 0.00 0.00") # new line for the textfile
                        writer.writerow(["g", str(np1x), str(np1y), str(np1z), str(np2x), str(np2y), str(np2z), str(np3x), str(np3y), str(np3z), str(np4x), str(np4y), str(np4z), str(np5x), str(np5y), str(np5z), str(np6x), str(np6y), str(np6z), str(np7x), str(np7y), str(np7z), str(np8x), str(np8y), str(np8z), "0.00", "0.00"]) # [theoutline]) # write next line
                        
                      # end
                    # end
                  if (num == 3): # if only three points are left
                    
                    point1=thepoints[0] # select last three points
                    point2=thepoints[1]
                    point3=thepoints[2]
                    
                    p1x = point1.x() # same procedure as above
                    p1y = point1.y()
                    p1z = theINPolyHField[a]
                    p2x = point2.x()
                    p2y = point2.y()
                    p2z = theINPolyHField[a]
                    p3x = point3.x()
                    p3y = point3.y()
                    p3z = theINPolyHField[a]
                    p4x = point3.x() + ((point1.x() - point3.x()) / 2.0)
                    p4y = point3.y() + ((point1.y() - point3.y()) / 2.0)
                    p4z = theINPolyHField[a]
                    
                    np1x = '%.2f' % round(p1x - cx, 2)
                    np1y = '%.2f' % round(p1y - cy, 2)
                    np1z = '%.2f' % round(p1z - ch, 2)
                    
                    np2x = '%.2f' % round(p2x - cx, 2)
                    np2y = '%.2f' % round(p2y - cy, 2)
                    np2z = '%.2f' % round(p2z - ch, 2)
                    
                    np3x = '%.2f' % round(p3x - cx, 2)
                    np3y = '%.2f' % round(p3y - cy, 2)
                    np3z = '%.2f' % round(p3z - ch, 2)
                    
                    np4x = '%.2f' % round(p4x - cx, 2)
                    np4y = '%.2f' % round(p4y - cy, 2)
                    np4z = '%.2f' % round(p4z - ch, 2)        
                    
                    np5x = '%.2f' % round(p1x - cx, 2)
                    np5y = '%.2f' % round(p1y - cy, 2)
                    np5z = '%.2f' % round(0, 2)
                    
                    np6x = '%.2f' % round(p2x - cx, 2)
                    np6y = '%.2f' % round(p2y - cy, 2)
                    np6z = '%.2f' % round(0, 2)
                    
                    np7x = '%.2f' % round(p3x - cx, 2)
                    np7y = '%.2f' % round(p3y - cy, 2)
                    np7z = '%.2f' % round(0, 2)
                    
                    np8x = '%.2f' % round(p4x - cx, 2)
                    np8y = '%.2f' % round(p4y - cy, 2)
                    np8z = '%.2f' % round(0, 2)
                    
                    writer.writerow(["g", str(np1x), str(np1y), str(np1z), str(np2x), str(np2y), str(np2z), str(np3x), str(np3y), str(np3z), str(np4x), str(np4y), str(np4z), str(np5x), str(np5y), str(np5z), str(np6x), str(np6y), str(np6z), str(np7x), str(np7y), str(np7z), str(np8x), str(np8y), str(np8z), "0.00", "0.00"]) # [theoutline]) # write next line
                    
                    tr1 = 0
            
            ############ Vegetation from here ############
            
            if (dlg2.treesconf.isEnabled()): # if there is vegetation
              if (len(theFAShapeField) == len(theFAHField)):  # to catch an error if the extraction fails
                for f in range(len(theFAHField)):    # going through attribute table of veg. file
                  # QMessageBox.information(None, "DEBUG:", str("Working on tree " + str(f+1) + " of " + str(len(theFAHField))))
                  Fashape = theFAShapeField[f] # Geometry (coordinates)
                  Fah = theFAHField[f] # Parameters
                  Far = theFARField[f]
                  Fal = theFALField[f]
                  Fad = theFADField[f]
                  FaType = theFATipeField[f] # Type of tree
                  fax = (Fashape[0]) - cx # calculate relative coordinates (fa hungarian for trees)
                  fay = (Fashape[1]) - cy
                  writer.writerow([FaType, str(fax), str(fay), str(Fah), str(Far), str(Fal), str(Fad), "0.30", "0.95"])
              else:
                QMessageBox.critical(None, "Error converting trees", str(str(len(theFAShapeField)) + " geometries for " + str(len(theFAHField)) + "trees."))
                # Problem if center point is overlapped by trunc of a tree. Should be tested and center point should be moved if its the case. 
            del writer # close file
          QMessageBox.information(None, "Succes", "The obstacle files are ready! :)")
      else:
        QMessageBox.critical(None, "Conversion could not be performed", str("Invalid field index: Building hight field no. = " + str(dlg2.Sel_buildhight_field.currentIndex()) + ", point elevation field no." + str(dlg2.Sel_centerpoints_field.currentIndex())))
    else:
      if (dlg2.treesconf.isEnabled()):
        QMessageBox.critical(None, "Conversion could not be performed", str("Invalid layer: Buildings = " + str(build.name()) + ", Center points = " + str(center_points.name()) + ", trees = " + str(trees.name()) ))
      else:
        QMessageBox.critical(None, "Conversion could not be performed", str("Invalid layer: Buildings = " + str(build.name()) + ", Center points = " + str(center_points.name()) ))
    dlg2.close()
  
  def SecondFunction(self): 
        
      global dlg2 
      dlg2 = ShowDialog2()
      
      global canvas
      dlg1.close()
      canvas = self.iface.mapCanvas()
      # theView = qgis.utils.iface.legendInterface().layers()  # gives back a list with active layers 
      theView = canvas.layers() 
      layerNames = []
      for layer in theView:
        layerNames.append(str(layer.name())) #returns a list containing the names of all currently visible layers
      
      dlg2.Sel_Build_Layer.addItems(layerNames) # Add layer names to "Select Buildings Layer" dropdown menu
      dlg2.Sel_Build_Layer.setCurrentIndex(0) # Set selected item to first item (to avoid the -1st Layer being selected if nothing is changed
      self.build_Layer_Index_Changed(0)  # populate building layer fields dropdown
      dlg2.Sel_Tree_Layer.addItems(layerNames) # Add layer names to "Select Trees Layer" dropdown menu
      dlg2.Sel_Tree_Layer.setCurrentIndex(0) # Set selected item to first item (to avoid the -1st Layer being selected if nothing is changed
      dlg2.Sel_centerpoints_layer.addItems('-')
      dlg2.Sel_centerpoints_layer.addItems(layerNames) # Add layer names to "Select Centerpoints Layer" dropdown menu
      dlg2.Sel_centerpoints_layer.setCurrentIndex(0) # Set selected item to first item (to avoid the -1st Layer being selected if nothing is changed
      # self.centerpoints_Layer_Index_Changed(0)  # populate building layer fields dropdown
      
      currentprofile = self.projectfilepathname() 
      currentprofile_dir = currentprofile[0]
      currentprofile_file = currentprofile[1]
      dlg2.outdir.setText( currentprofile_dir ) 
      dlg2.outfile.setText( currentprofile_file )
      
      # Set connections for buttons and dropdown signals
      dlg2.Cancel.clicked.connect(dlg2.close)
      dlg2.Help.clicked.connect(self.shwhelp)
      dlg2.Convert.clicked.connect(self.ConvertFunction) #(canvas, dlg2)) 
      dlg2.Sel_Build_Layer.activated[int].connect(self.build_Layer_Index_Changed) #(canvas, dlg2))
      dlg2.Sel_Tree_Layer.activated[int].connect(self.tree_Layer_Index_Changed) #(canvas, dlg2))
      dlg2.Sel_centerpoints_layer.activated[int].connect(self.centerpoints_Layer_Index_Changed) #(canvas, dlg2))
            
      dlg2.show() # Show second dialog
      dlg2.exec_()
      


  # run method that performs all the real work
  def run(self): 
    # create and show the dialog 
    global dlg1
    dlg1 = ShowDialog1()
    # QtCore.QObject.connect(dlg1.Cancel1, QtCore.SIGNAL("clicked()"), dlg1.close)  # depr!
    # QtCore.QObject.connect(dlg1.Next1, QtCore.SIGNAL("clicked()"), self.SecondFunction)  # depr! 
    dlg1.Cancel1.clicked.connect(dlg1.close)
    dlg1.Next1.clicked.connect(self.SecondFunction) 
    # show the dialog
    dlg1.show()
    dlg1.exec_() 
    
